/*
    Copyright (C) 2004 by Frank Richter

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef __CS_DETECTDRIVER_H__
#define __CS_DETECTDRIVER_H__

class csDetectDriver
{
  bool verbose;
  char* DriverDLL;
  char* DriverVersion;

  void DetermineDriver (const char* monitorName);
  void DetermineDriverVersion();
public:
  csDetectDriver();
  ~csDetectDriver();

  void SetVerbose (bool flag) { verbose = flag; }
  void DoDetection (HWND window, HDC dc);

  const char* GetDriverDLL() const
  { return DriverDLL; }
  const char* GetDriverVersion() const
  { return DriverVersion; }
};

#endif // __CS_DETECTDRIVER_H__
